package rac.test;

import junit.framework.TestCase;
import rac.*;
import listFW.*;
import listFW.factory.*;

/**
 */
public class TestRACHeap extends TestCase {
    
    static class TestObject implements Comparable<TestObject> {
        private int _priority;
        private String _val;
        
        public TestObject(int p, String v) {
            _priority = p;
            _val = v;
        }
        
        /**
         * Order is based on the priority field.
         */
        public int compareTo(TestObject other) {
            return _priority - other._priority;
        }
        
        public void setPriority(int p) {
            _priority = p;
        }
        
        public String toString() {
            return "[" + _priority + ", " + _val + "]";
        }
    }
    
    IListFactory lf = CompositeListFactory.Singleton;
    
    /**
     * Simple test by visual inspection of the heap array.
     */
    public void testUpdate() {
        RACHeap heap = new RACHeap();
        TestObject x = new TestObject(20, "Test Object");
        heap.put(x);
        System.out.println(heap.elements(lf));
        heap.put(new TestObject(10, "Ten"));
        System.out.println(heap.elements(lf));
        heap.put(new TestObject(30, "OK"));
        System.out.println(heap.elements(lf));
        x.setPriority(5);
        heap.update(x);
        System.out.println(heap.elements(lf));  // x should be at the top of the heap!
        x.setPriority(40);
        heap.update(x);
        System.out.println(heap.elements(lf));  // x should no longer be at the top of the heap!
    }
    
}
